projectiles = {
[_projectile_rocket]="a rocket launcher",
[_projectile_grenade]="a grenade",
[_projectile_pistol_bullet]="a pistol",
[_projectile_rifle_bullet]="an AR",
[_projectile_shotgun_bullet]="a shotgun",
[_projectile_staff]="a staff",
[_projectile_staff_bolt]="a staff",
[_projectile_flamethrower_burst]="a flamethrower",
[_projectile_compiler_bolt_minor]="psychic powers",
[_projectile_compiler_bolt_major]="psychic powers",
[_projectile_alien_weapon]="an alien weapon",
[_projectile_fusion_bolt_minor]="a fusion pistol",
[_projectile_fusion_bolt_major]="a fusion pistol",
[_projectile_hunter]="a hunter cannon",
[_projectile_fist]="a fist",
[_projectile_armageddon_sphere]="a reaper laser",
[_projectile_armageddon_electricity]="a reaper laser",
[_projectile_juggernaut_rocket]="a rocket launcher",
[_projectile_trooper_bullet]="a Pfhor AR",
[_projectile_trooper_grenade]="a Pfhor grenade",
[_projectile_minor_defender]="a S'pht'kr cannon",
[_projectile_major_defender]="a S'pht'kr cannon",
[_projectile_juggernaut_missile]="a rocket launcher",
[_projectile_minor_energy_drain]="digestive juices",
[_projectile_major_energy_drain]="digestive juices",
[_projectile_oxygen_drain]="digestive juices",
[_projectile_minor_hummer]="a drone gun",
[_projectile_major_hummer]="a drone gun",
[_projectile_durandal_hummer]="a drone gun",
[_projectile_minor_cyborg_ball]="a Pfhor grenade",
[_projectile_major_cyborg_ball]="a Pfhor grenate",
[_projectile_ball]="a ball",
[_projectile_minor_fusion_dispersal]="fusion backblast",
[_projectile_major_fusion_dispersal]="fusion backblast",
[_projectile_overloaded_fusion_dispersal]="an exploding fusion pistol",
[_projectile_yeti]="its claws",
[_projectile_sewage_yeti]="dung",
[_projectile_lava_yeti]="lava",
[_projectile_smg_bullet]="an SMG"
}

damages = {
[_damage_explosion]={"blew", "apart"},
[_damage_staff]={"hacked", ""},
[_damage_projectile]={"shot", ""},
[_damage_absorbed]={"invincibilifieded?!", ""},
[_damage_flame]={"melted", ""},
[_damage_claws]={"scratched", ""},
[_damage_alien_weapon]={"alienated", ""},
[_damage_hulk_slap]={"slapped", ""},
[_damage_compiler]={"derezzed", ""},
[_damage_fusion]={"fused", ""},
[_damage_hunter]={"slew", ""},
[_damage_fists]={"pounded", ""},
[_damage_teleporter]={"teleported", ""},
[_damage_defender]={"offended", ""},
[_damage_yeti_claws]={"scratched", ""},
[_damage_yeti_projectile]={"dunged", ""},
[_damage_crushing]={"crushed", ""},
[_damage_suffocation]={"suffocated", ""},
[_damage_goo]={"decomposed", ""},
[_damage_energy_drain]={"drained", ""},
[_damage_oxygen_drain]={"drained", ""},
[_damage_drone]={"droned", ""},
[_damage_shotgun]={"riddled", "full of holes"}
}

degrees = {
[5]={msg="on a killing spree", adj="killing spree"},
[10]={msg="on a rampage", adj="rampage"},
[15]={msg="dominating", adj="domination"},
[20]={msg="unstoppable", adj="unstoppability"},
[25]={msg="godlike", adj="godliness"}
}

function init()
	kills = {}
	for n=1,number_of_players(),1 do
		kills[n] = 0
	end
end

function verb(noun, verb)
	verb = damages[verb] or {"killed", ""}
	if(noun) then noun = " " .. noun else noun = "" end
	if(verb[2] ~= "") then
		return verb[1] .. noun .. " " .. verb[2]
	else
		return verb[1] .. noun
	end
end

function player_damaged(victim, victor, monster, type, amount, projectile)
	if(victor >= 0 and victim ~= victor and get_player_team(victim) == get_player_team(victor)) then
		set_life(victim, get_life(victim) + amount)
	end
	if(get_life(victim) < 0) then
		local by = "with"
		local msg = ""
		--[[ suicide ]]
		if(victim == victor) then
			msg = get_player_name(victor) .. " " .. verb("themselves", type)
		--[[ PK ]]
		elseif(victor > -1) then
			msg = get_player_name(victor) .. " " .. verb(get_player_name(victim), type)
		--[[ monster ]]
		elseif(monster > -1) then
			msg = "A monster " .. verb(get_player_name(victim), type)
		--[[ environment ]]
		else
			msg = get_player_name(victim) .. " was " .. verb(nil, type)
			by = "by"
		end
		if(projectile > -1) then
			local proj
			proj = projectiles[get_projectile_type(projectile)]
			if(proj) then
				msg = msg .. " " .. by .. " " .. proj
			end
		end
		screen_print(msg)
		--[[ give victor a kill and output a message? ]]
		if(victim ~= victor and victor > -1) then
			kills[victor + 1] = kills[victor + 1] + 1
			if(kills[victim + 1] > 0) then
				for n=25,5,-5 do
					if(n <= kills[victim + 1]) then
						screen_print(get_player_name(victim) .. "'s " .. degrees[n].adj .. " was stopped by " .. get_player_name(victor))
						break
					end
				end
			end
			local deg
			deg = degrees[kills[victor + 1]]
			if(deg) then deg = deg.msg end
			if(deg) then
				screen_print(get_player_name(victor) .. " is " .. deg .. "!")
			end
		elseif(victim ~= victor and monster > -1) then
			if(kills[victim + 1] > 0) then
				for n=25,5,-5 do
					if(n <= kills[victim + 1]) then
						screen_print(get_player_name(victim) .. "'s " .. degrees[n].adj .. " was stopped by a monster")
						break
					end
				end
			end
		else
			if(kills[victim + 1] > 0) then
				for n=25,5,-5 do
					if(n <= kills[victim + 1]) then
						screen_print(get_player_name(victim) .. "'s " .. degrees[n].adj .. " has met a premature end.")
						break
					end
				end
			end
		end
		kills[victim + 1] = 0
	end
end